# Running the Tests

Choose your operating system:

* [Windows](#windows)
* [Mac OS X](#mac-os-x)
* [Linux](#linux)

----

# Windows

1. Open a Command Prompt.
2. Get the first exercise:

     ```batchfile
     C:\Users\JohnDoe>exercism fetch java

     Not Submitted:     1 problem
     java (Hello World) C:\Users\JohnDoe\exercism\java\hello-world

     New:               1 problem
     java (Hello World) C:\Users\JohnDoe\exercism\java\hello-world

     unchanged: 0, updated: 0, new: 1
   ```

3. Change directory into the exercism:

     ```batchfile
     C:\Users\JohnDoe>cd C:\Users\JohnDoe\exercism\java\hello-world
     ```
   
4. Run the tests:

     ```batchfile
     C:\Users\JohnDoe>gradle test
     ```
   *(Don't worry about the tests failing, at first, this is how you begin each exercise.)*

5. Solve the exercise.  Find and work through the `TUTORIAL.md` guide ([view on GitHub](https://github.com/exercism/java/blob/master/exercises/hello-world/TUTORIAL.md)).


Good luck!  Have fun!

If you get stuck, at any point, don't forget to reach out for [help](http://exercism.io/languages/java/help).

----

# Mac OS X

1. In the terminal window, get the first exercise:

     ```
     $ exercism fetch java

     New:                 1 problem
     Java (Etl) /Users/johndoe/exercism/java/hello-world

     unchanged: 0, updated: 0, new: 1
    ```

2. Change directory into the exercise:

     ```
     $ cd /Users/johndoe/exercism/java/hello-world
     ```

3. Run the tests:

    ```
    $ gradle test
    ```
   *(Don't worry about the tests failing, at first, this is how you begin each exercise.)*

4. Solve the exercise.  Find and work through the `TUTORIAL.md` guide ([view on GitHub](https://github.com/exercism/java/blob/master/exercises/hello-world/TUTORIAL.md)).

Good luck!  Have fun!

If you get stuck, at any point, don't forget to reach out for [help](http://exercism.io/languages/java/help).

----

# Linux

1. In the terminal window, get the first exercise:

     ```
     $ exercism fetch java

     New:                 1 problem
     Java (Etl) /home/johndoe/exercism/java/hello-world

     unchanged: 0, updated: 0, new: 1

    ```

2. Change directory into the exercise:

     ```
     $ cd /home/johndoe/exercism/java/hello-world
     ```

3. Run the tests:

    ```
    $ gradle test
    ```
   *(Don't worry about the tests failing, at first, this is how you begin each exercise.)*

4. Solve the exercise.  Find and work through the `TUTORIAL.md` guide ([view on GitHub](https://github.com/exercism/java/blob/master/exercises/hello-world/TUTORIAL.md)).

Good luck!  Have fun!

If you get stuck, at any point, don't forget to reach out for [help](http://exercism.io/languages/java/help).

